#Data acquisition AD7327
# Connecting to the JTAG
puts "Acquiring data"
set startacq 0
set mm [ lindex [ get_service_paths master ] 0 ]
# In case there is a previous opened connection, close the connection
close_service master $mm
open_service master $mm

# In case the previous executed script crashed, and the software is an intermediate state
# Allow the program to enter in the main while loop
master_write_memory $mm 0x1AFE1 1
master_write_memory $mm 0x1AFE2 1
master_write_memory $mm 0x1AFE3 1

# Receive the address of memory where the acquired data is stored
set address [ master_read_32 $mm 0x1AFE8 1 ]

# Program the HDL driver
# Write
 set control [ expr  1 << 15]
# Channel ( 0 to 7 )
 set channel 0
 set control [ expr $control + [ expr $channel << 10 ] ]
# Select Mode ( 8 Single ended inputs = 0 , 4 Pseudo Diferential Inputs = 1, 4 Fully Differential inputs = 2, 7 Pseudo differential inputs = 3)
 set mode 0
 set control [ expr $control + [ expr $mode << 8 ] ]
# Power ( Normal = 0, Auto standby = 1, Auto shutdown = 2, Full shutdown = 3 )
 set power 0
 set control [ expr $control + [ expr $power << 6 ] ]
# Coding ( 2's complement = 0, Straight binary = 1 )
 set coding 0
 set control [ expr $control + [ expr $coding << 5 ] ]
# Reference ( External = 0, Internal = 1)
 set reference 0
 set control [ expr $control + [ expr $reference << 4 ] ]
# Sequencer ( Not used = 0, Use sequence register = 1 , Use sequencer without sequence register = 2, Not used = 3)
 set sequencer 0
 set control [ expr $control + [ expr $sequencer << 2 ] ]

# Clean variables
unset sequencer
unset channel
unset power
unset reference

# Shadow Register  (uncomment the lines corresponding to the VIN bit you want activated )
# Write
 set sequence [ expr  1 << 15]
#select sequence register
 set sequence [ expr $sequence + [expr 3 << 13 ] ]
# VIN0
# set sequence [ expr $sequence + [expr 1 << 12 ] ]
# VIN1
# set sequence [ expr $sequence + [expr 1 << 11 ] ]
# VIN2
# set sequence [ expr $sequence + [expr 1 << 10 ] ]
# VIN3
# set sequence [ expr $sequence + [expr 1 << 9  ] ]
# VIN4
# set sequence [ expr $sequence + [expr 1 << 8 ] ]
# VIN5
# set sequence [ expr $sequence + [expr 1 << 7 ] ]
# VIN6
# set sequence [ expr $sequence + [expr 1 << 6 ] ]
# VIN7
# set sequence [ expr $sequence + [expr 1 << 5 ] ]


# Range Register 1
# Write
 set range1 [ expr  1 << 15 ]
#select rage register 1
 set range1 [ expr $range1 + [expr 1 << 13 ] ]
# Set VinOA
 set Vin0a 0
 set range1 [ expr $range1 + [expr $Vin0a << 12 ] ]
# Set VinOB
 set Vin0b 0
 set range1 [ expr $range1 + [expr $Vin0b << 11 ] ]
# Set Vin1A
 set Vin1a 0
 set range1 [ expr $range1 + [expr $Vin1a << 10 ] ]
# Set Vin1B
 set Vin1b 0
 set range1 [ expr $range1 + [expr $Vin1b << 9 ] ]
# Set Vin2A
 set Vin2a 0
 set range1 [ expr $range1 + [expr $Vin2a << 8 ] ]
# Set Vin2B
 set Vin2b 0
 set range1 [ expr $range1 + [expr $Vin2b << 7 ] ]
# Set Vin3A
 set Vin3a 0
 set range1 [ expr $range1 + [expr $Vin3a << 6 ] ]
# Set Vin3b
 set Vin3b 0
 set range1 [ expr $range1 + [expr $Vin3b << 5 ] ]

# Clean variables
unset Vin0a
unset Vin0b
unset Vin1a
unset Vin1b
unset Vin2a
unset Vin2b
unset Vin3a
unset Vin3b

# Range Register 2
# Write
 set range2 [ expr  1 << 15]
#select rage register 1
 set range2 [ expr $range2 + [expr 2 << 13 ] ]
# Set Vin4A
 set Vin4a 0
 set range2 [ expr $range2 + [expr $Vin4a << 12 ] ]
# Set Vin4B
 set Vin4b 0
 set range2 [ expr $range2 + [expr $Vin4b << 11 ] ]
# Set Vin5A
 set Vin5a 0
 set range2 [ expr $range2 + [expr $Vin5a << 10 ] ]
# Set Vin5B
 set Vin5b 0
 set range2 [ expr $range2 + [expr $Vin5b << 9 ] ]
# Set Vin6A
 set Vin6a 0
 set range2 [ expr $range2 + [expr $Vin6a << 8 ] ]
# Set Vin6B
 set Vin6b 0
 set range2 [ expr $range2 + [expr $Vin6b << 7 ] ]
# Set Vin7A
 set Vin7a 0
 set range2 [ expr $range2 + [expr $Vin7a << 6 ] ]
# Set Vin7b
 set Vin7b 0
 set range2 [ expr $range2 + [expr $Vin7b << 5 ] ]

# Clean variables
unset Vin4a
unset Vin4b
unset Vin5a
unset Vin5b
unset Vin6a
unset Vin6b
unset Vin7a
unset Vin7b

# Program the Range register 1
master_write_32 $mm 0x1AFE4 $range1
after 500
# Program the Range register 2
master_write_32 $mm 0x1AFE4 $range2
after 500
# Program the Sequence register
master_write_32 $mm 0x1AFE4 $sequence
after 500
# Program the control register
master_write_32 $mm 0x1AFE4 $control
after 500
# Do not transmit new data to the ADC
master_write_32 $mm 0x1AFE4 0

# Clean variables
unset range1
unset range2
unset sequence
unset control

# Start the acquisition process
set startacq [ master_read_memory $mm 0x1AFE0 1 ]
set point [ master_read_32 $mm 0x1AFEC 1 ]
master_write_32 $mm $point 1

# Wait for the data to be acquired by the ADC and stored in the memory
while {$startacq == 0} {
    set startacq [ master_read_memory $mm 0x1AFE0 1 ]
    }
    puts "Acquisition has been started..."

# Read data from memory byte by byte
    set data [ master_read_memory $mm $address 32768 ]

# Signal to the application that data has been acquired
    master_write_memory $mm 0x1AFE1 1
# Converts data from bytes to 16 bit values
    puts "Converting acquired data to 16 bit values"
    for { set i 0 } { $i < [ llength $data ] } { incr i 4} {
        set a [ lindex $data $i ]
        set b [ lindex $data [expr $i + 1 ] ]
        set c [ lindex $data [expr $i + 2 ] ]
        set d [ lindex $data [expr $i + 3 ] ]
        lappend newData [ expr  {( $d << 24 ) + ( $c << 16 ) + ( $b << 8 ) + $a } ]
    }

# Clean variables
unset a
unset b
unset c
unset d
unset data

# Create 8 lists, one for each channel
set final0 "Vin0"
set final1 "Vin1"
set final2 "Vin2"
set final3 "Vin3"
set final4 "Vin4"
set final5 "Vin5"
set final6 "Vin6"
set final7 "Vin7"

# Sorts data through channels and removes the channel number from the initial 4 bits
# If conding is 2's complement, process data
puts "Processing data"
for { set i 0 } { $i < [ llength $newData ] } { incr i} {
    set a [lindex $newData $i ]
    set decimal [ expr $a ]
    switch [ expr $decimal / 8192 ] {
        0   {
            if { $coding == 0 } {
                if { $decimal > 4096 } {
                    set decimal [expr $decimal - 8192]
                }
            }
            lappend final0 $decimal
        }
        1   {
            set decimal [expr $decimal - 8192]
            if { $coding == 0 } {
                if { $decimal > 4096 } {
                    set decimal [expr $decimal - 8192]
                }
            }
            lappend final1 $decimal
        }
        2   {
            set decimal [expr $decimal - 16384 ]
            if { $coding == 0 } {
                if { $decimal > 4096 } {
                    set decimal [expr $decimal - 8192]
                }
            }
            lappend final2 $decimal
        }
        3   {
            set decimal [expr $decimal - 24576 ]
            if { $coding == 0 } {
                if { $decimal > 4096 } {
                    set decimal [expr $decimal - 8192]
                }
            }
            lappend final3 $decimal
        }
        4   {
            set decimal [expr $decimal - 32768 ]
            if { $coding == 0 } {
                if { $decimal > 4096 } {
                    set decimal [expr $decimal - 8192]
                }
            }
            lappend final4 $decimal
        }
        5   {
            set decimal [expr $decimal - 40960 ]
            if { $coding == 0 } {
                if { $decimal > 4096 } {
                    set decimal [expr $decimal - 8192]
                }
            }
            lappend final5 $decimal
        }
        6   {
            set decimal [expr $decimal - 49152 ]
            if { $coding == 0 } {
                if { $decimal > 4096 } {
                    set decimal [expr $decimal - 8192]
                }
            }
            lappend final6 $decimal
        }
        7   {
            set decimal [expr $decimal - 57344 ]
            if { $coding == 0 } {
                if { $decimal > 4096 } {
                    set decimal [expr $decimal - 8192]
                }
            }
            lappend final7 $decimal
        }
        default {
            puts $decimal
            puts "ERR"
        }
    }
}

# clean intermediary variables
unset decimal
unset newData

# Arranging data by channel
# variable used to signal when no new data is available
set data_processed 1

puts "Arranging channels"
for { set i 0 } { $i < 8193  } { incr i} {
    if { [ llength $final0 ] > [ expr {$i ? $i : 1} ] } {
        lappend final [ lindex $final0 $i ],
        set data_processed 1
    }

    if { [ llength $final1 ] >  [ expr {$i ? $i : 1} ] } {
        lappend final [ lindex $final1 $i ],
        set data_processed 1
    }

    if { [ llength $final2 ] > [ expr {$i ? $i : 1} ] } {
        lappend final [ lindex $final2 $i ],
        set data_processed 1
    }

    if { [llength $final3] > [ expr {$i ? $i : 1} ] } {
        lappend final [lindex $final3 $i],
        set data_processed 1
    }

    if { [llength $final4] > [ expr {$i ? $i : 1} ] } {
        lappend final [lindex $final4 $i],
        set data_processed 1
    }

    if { [llength $final5] > [ expr {$i ? $i : 1} ] } {
        lappend final [lindex $final5 $i],
        set data_processed 1
    }

    if { [llength $final6] > [ expr {$i ? $i : 1} ] } {
        lappend final [lindex $final6 $i],
        set data_processed 1
    }

    if { [llength $final7] > [ expr {$i ? $i : 1} ] } {
        lappend final [lindex $final7 $i],
        set data_processed 1
    }

    if { $data_processed == 0 } {
        break
    }
    lappend final \n
    set data_processed 0
}

master_write_memory $mm 0x1AFE2 1

# Writes the sorted data to a file
puts "Moving data into file Acquisition.csv"

set openFile 0

while { $openFile == 0 } {
    if [catch { open "Acquisition.csv" "a+" } fid ] {
        puts stderr "Error opening the file. Please make sure the file is not opened by another program"
        after 1000
        puts "Trying again..."
    } else {
        set fd $fid
        set openFile 1
        puts "File opened"
    }
}
#set fd [ open "Acquisition.csv" "a+" ]
#fconfigure $fd -translation binary
puts -nonewline $fd [ join $final ]
close $fd
master_write_memory $mm 0x1AFE3 1
unset final
puts "Iteration complete"
close_service master $mm
