// Copyright (C) 1991-2011 Altera Corporation
// Your use of Altera Corporation's design tools, logic functions
// and other software and tools, and its AMPP partner logic
// functions, and any output files from any of the foregoing
// (including device programming or simulation files), and any
// associated documentation or information are expressly subject
// to the terms and conditions of the Altera Program License
// Subscription Agreement, Altera MegaCore Function License
// Agreement, or other applicable license agreement, including,
// without limitation, that your use is for the sole purpose of
// programming logic devices manufactured by Altera and sold by
// Altera or its authorized distributors.  Please refer to the
// applicable agreement for further details.

// *****************************************************************************
// This file contains a Verilog test bench template that is freely editable to
// suit user's needs .Comments are provided in each section to help the user
// fill out necessary details.
// *****************************************************************************
// Generated on "04/11/2012 11:29:28"

// Verilog Test Bench template for design : AD7327
//
// Simulation tool : ModelSim-Altera (Verilog)
//

`timescale 1 ns/ 100 ps
module AD7327_vlg_tst();
// constants
// test vector input registers
reg [15:0] data_adc;
reg [15:0] data_adc_internal;
reg [15:0] data_i;
reg fpga_clk_i;
reg adc_clk_i;
reg reset_i;
reg adc_sdo_i;
reg wr_data_n_i;
// wires
wire adc_cs_n_o;
wire adc_sclk_o;
wire adc_sdi_o;
wire [15:0] data_o;
wire data_rd_ready_o;
wire data_wr_ready_o;

// assign statements (if any)
AD7327 i1 (
// port map - connection between master ports and signals/registers
    .fpga_clk_i(fpga_clk_i),
    .adc_clk_i(adc_clk_i),
    .reset_i(reset_i),

    .wr_data_n_i(wr_data_n_i),

    .data_i(data_i),
    .data_o(data_o),
    .data_rd_ready_o(data_rd_ready_o),
    .data_wr_ready_o(data_wr_ready_o),

    .adc_sdo_i(adc_sdo_i),
    .adc_sdi_o(adc_sdi_o),
    .adc_sclk_o(adc_sclk_o),
    .adc_cs_n_o(adc_cs_n_o)
);
initial
begin
    fpga_clk_i          = 1'b0;
    adc_clk_i           = 1'b0;
    reset_i             = 1;
    wr_data_n_i         = 1;
    data_i              = 16'h5;
    data_adc_internal   = 16'h0;
    #100
    reset_i         = 0;
    #100
    wr_data_n_i     = 1'b0;
    wait( data_wr_ready_o)
    begin
        wr_data_n_i = 1'b1;
    end
$display("Running testbench");
end

always
begin
    #50 adc_clk_i = ~adc_clk_i;
end

always
begin
    #5 fpga_clk_i = ~fpga_clk_i;
end

always @(negedge adc_cs_n_o)
begin
    data_adc_internal   = data_adc_internal + 16'h1;// at CS activation, update the data register
    data_adc            = data_adc_internal;
    #14 adc_sdo_i       = 1'bx;                     // t3 delay for 5V
    #21 adc_sdo_i       = data_adc[15];             // t2 delay for 5V
end

always @(negedge adc_sclk_o)
begin
  #43                                               // t4 delay for 5V
  data_adc  = {data_adc [14:0],1'bz};
  adc_sdo_i = data_adc[15];
end

endmodule

